kind: ConfigMap
apiVersion: v1
metadata:
  name: {{ gogs_name }}
  namespace: {{ namespace }}
data:
  app.ini: |
    BRAND_NAME = Gogs
    RUN_USER = ""
    RUN_MODE = prod

    [database]
    DB_TYPE  = postgres
    HOST     = {{ gogs_pg_name }}:5432
    NAME     = {{ gogs_db_secret.resources[0].data['database-name'] | b64decode }}
    USER     = {{ gogs_db_secret.resources[0].data['database-user'] | b64decode }}
    PASSWD   = {{ gogs_db_secret.resources[0].data['database-password'] | b64decode }}
    SSL_MODE = disable
    PATH     = data/gogs.db

    [log]
    MODE      = console
{% if do_debugs %}
    LEVEL     = Trace
{% else %}
    LEVEL     = Info
{% endif %}

    [email]
{% if smtp_relay | default(False) or smtp_address | default(False) or smtps_address | default(False) %}
    ENABLED        = true
    FROM           = {{ gogs_noreply | default('noreply@' ~ root_domain) }}
{% if smtp_relay | default(False) %}
    HOST           = {{ smtp_relay }}:{{ smtp_port | default(25) }}
{% elif smtps_address | default(False) %}
    # warning: port needs to end in 465 for SMTPs to be enabled - which is stupid ...
    # see https://github.com/gogs/gogs/blob/main/conf/app.ini#L181
    HOST           = {{ smtps_address | urlsplit('hostname') }}:{{ smtps_address | urlsplit('port') }}
{% else %}
    HOST           = {{ smtp_address | urlsplit('hostname') }}:{{ smtp_address | urlsplit('port') }}
{% endif %}
    SUBJECT_PREFIX = `[%(BRAND_NAME)s] `
{% else %}
    ENABLED = false
{% endif %}

    [markup.asciidoc]
    ENABLED         = true
    FILE_EXTENSIONS = .adoc,.asciidoc
    RENDER_COMMAND  = "asciidoc --out-file=- -"
    IS_INPUT_FILE   = false

    [mirror]
    DEFAULT_INTERVAL = 8

    [picture]
    DISABLE_GRAVATAR        = false
    ENABLE_FEDERATED_AVATAR = true

    [prometheus]
{% if do_exporters %}
    ENABLED           = true
    ENABLE_BASIC_AUTH = false
{% else %}
    ENABLED = false
{% endif %}

    [repository]
    PREFERRED_LICENSES = MIT License,Apache License 2.0
    ROOT               =

    [security]
    INSTALL_LOCK   = true
    SECRET_KEY     = {{ secret_key }}

    [server]
    SSH_DOMAIN       = {{ gogs_fqdn }}
    DOMAIN           = {{ gogs_fqdn }}
    HTTP_PORT        = 3000
    SSH_PORT         = 2022
    ROOT_URL         = https://{{ gogs_fqdn }}
    LOCAL_ROOT_URL   = http://{{ gogs_name }}.{{ namespace }}.svc.{{ cluster_domain }}
    DISABLE_SSH      = true
    START_SSH_SERVER = false
    LFS_START_SERVER = false
    OFFLINE_MODE     = false

    [service]
    REGISTER_EMAIL_CONFIRM            = false
    ENABLE_NOTIFY_MAIL                = false
{% if (gogs_admin_secret | default([])) | length > 0 and gogs_disable_registrations %}
    DISABLE_REGISTRATION              = true
{% else %}
    DISABLE_REGISTRATION              = false
{% endif %}
    ENABLE_CAPTCHA                    = false
    REQUIRE_SIGNIN_VIEW               = false
    DEFAULT_KEEP_EMAIL_PRIVATE        = false
    DEFAULT_ALLOW_CREATE_ORGANIZATION = true
    DEFAULT_ENABLE_TIMETRACKING       = true
    NO_REPLY_ADDRESS                  = {{ gogs_noreply | default('noreply@' ~ root_domain) }}

    [session]
{% if gogs_sessions_provider | default('file') == 'redis' %}
    PROVIDER        = redis
    PROVIDER_CONFIG = network=tcp,addr={{ redis_name }}.{{  namespace }}.svc.{{ cluster_domain }}:6379,{% if redis_uses_password | default(False) %}password={{ redis_uses_password }},{% endif %}db={{ redis_db | default(0) }},pool_size=100,idle_timeout=180
{% elif gogs_sessions_provider | default('file') == 'memory' %}
    PROVIDER = memory
{% else %}
    PROVIDER        = file
    PROVIDER_CONFIG = /data/gogs/sessions
{% endif %}

    [webhook]
    TASK_INTERVAL   = 1
    DELIVER_TIMEOUT = 10
    SKIP_TLS_VERIFY = true
